<template>
    <!-- <div> -->
        <v-app-bar app class="custom-header" color="primary-light" hide-on-scroll>
            <v-spacer></v-spacer>
            <v-toolbar-title class="header-title">
                <router-link :to="{ name: 'home' }" class="white--text" style="text-decoration: none;">
                    <h1>Tech2Rent</h1>
                </router-link>
            </v-toolbar-title>
            <v-spacer></v-spacer>
            
            <div v-if="loggedIn && getRoles && getRoles.includes('ROLE_COMPANY') > 0">
              <router-link :to="{ name: 'admin' }" class="white--text" style="text-decoration: none;">
                <v-btn color="secondary" small dark>
                    Mon entreprise
                </v-btn>
              </router-link>
            </div>

            <div v-if="loggedIn">
              <router-link :to="{ name: 'carts' }" class="white--text" style="text-decoration: none;">
                <v-btn dark icon>
                    <v-icon color="white">mdi-cart-outline</v-icon>
                </v-btn>
              </router-link>
            </div>

            <v-menu bottom offset-y transition="slide-y-transition">
                <template v-slot:activator="{ on, attrs }">
                    <v-btn dark icon v-bind="attrs" v-on="on">
                       <v-avatar color="indigo" size="30">
                        <v-img v-if="avatarUrl"  :src="avatarUrl" max-width="30"  rounded color="white" />
                        <v-icon v-if="!avatarUrl" color="white">mdi-account</v-icon>
                      </v-avatar>
                    </v-btn>
                </template>

                <v-list v-if="loggedIn">
                    <v-list-item v-for="(item, i) in loggedItems" :key="i" @click="handleAction(item)">
                        <v-list-item-icon>
                            <v-icon v-text="item.icon"></v-icon>
                        </v-list-item-icon>
                        <v-list-item-content>
                            <v-list-item-title>{{ item.title }}</v-list-item-title>
                        </v-list-item-content>
                    </v-list-item>
                </v-list>

                <v-list v-if="!loggedIn">
                    <v-list-item v-for="(item, i) in notLoggedItems" :key="i" @click="handleAction(item)">
                        <v-list-item-icon>
                            <v-icon v-text="item.icon"></v-icon>
                        </v-list-item-icon>
                        <v-list-item-content>
                            <v-list-item-title>{{ item.title }}</v-list-item-title>
                        </v-list-item-content>
                    </v-list-item>
                </v-list>
            </v-menu>
            <template v-slot:extension>
                <v-tabs class="custom-tab-nav" background-color="primary-dark secondary" slider-color="secondary" dark
                    fixed-tabs centered>
                    <v-tab v-for="item in tabsItems" :key="item.route">
                        <router-link :to="{ name: item.route }" class="white--text custom-tab-link">
                            <span>
                                {{item.title}}
                            </span>
                        </router-link>
                    </v-tab>
                </v-tabs>
            </template>

        </v-app-bar>
    <!-- </div> -->
</template>

<script>
import {ENTRYPOINT} from '../config/entrypoint';
import { mapGetters, mapActions } from 'vuex';
import { mapFields } from 'vuex-map-fields';
export default {
  name: 'Header',
  components: {
  },
  computed: {
    ...mapGetters('user', {
      loggedIn: 'getLoggedIn',
      getRoles: 'getRoles'
    }),
    ...mapFields('user',['userInfos'])
  },
  data: () => ({
    loggedItems: [
      { title: 'Profile' , icon:'mdi-account-box', action: 'redirect', route:'profileUser'},
      // { title: 'Entreprise' , icon:'mdi-account-box', action: 'redirect', route:'profileUser'},
      { title: 'Se déconnecter', icon:'mdi-logout', action: 'logout' },
    ],
    notLoggedItems: [
      { title: 'Connexion', icon:'mdi-login' , action: 'redirect', route:'login' },
      { title: 'Inscription', icon:'mdi-account-plus', action: 'redirect' ,route:'register' },
    ],
    tabsItems: [
       { title: 'Accueil' ,route:'home' },
       { title: 'Produits' ,route:'products' },
    ],
    selectedTab:null,
    avatarUrl: null
  }),
  mounted() {
    let localUserInfos = JSON.parse(localStorage.getItem('user'));
    if (localUserInfos && localUserInfos.id) {
      this.getProfile(localUserInfos.id);
    }
  },
  methods: {
    ...mapActions('user', ['logout', 'getProfile']),
    handleAction : function (value) {
      if (value.action === 'redirect') {
        this.$router.push({name :value.route});
      } else {
        this.logout();
        this.avatarUrl = null;
        this.$router.push({name : 'login'});
      }
    },
  },
  watch: {
    userInfos(newUserInfos) {
      if(newUserInfos && newUserInfos.id) {
        // this.getProfile(newUserInfos.id);
        if (newUserInfos.avatar && newUserInfos.avatar.filePath) {
          this.avatarUrl = ENTRYPOINT + '/media/' + newUserInfos.avatar.filePath;
        }
      }
    }
  },
};
</script>

<style>
  .custom-header  .v-toolbar__content {
    align-items: center !important;
    padding: 4px 95px;
  }

  .header-title {
    align-self: auto !important;
  }

  .custom-tab-nav {
    color: white;
  }

  .custom-tab-link {
    text-decoration: none;
    width: 100%;
    height: 100%;
  }
  .custom-tab-link span {
    line-height: 48px;
  }
</style>
